<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// start page
		// includes
		include("includes.php");
		
		// start output
		include("header.php");
		
		// set template
		$tp = new Template("tpl/asset.tpl", $config_yapter_error);
		
		// set language variables
		$tp->setvars($lang);
	
	// create letter links
		// build query
		$query = "SELECT
				SUBSTRING(UPPER(asset.asset_name),1,1) AS asset_letter
			FROM
				asset
			GROUP BY
				asset_letter
			ORDER BY
				asset_letter";
		
		// run query
		$alphabet = $db->db_select($query);
		
		// count results
		$alphabet_counter = count($alphabet);
		
		// any letters?
		if ($alphabet_counter>0) {
			// get objects
			foreach($alphabet AS $alphabet_letter) {
				// to tpl
				$tp->set("asset_letter", strtoupper($alphabet_letter['asset_letter']));
				
				// parse every row
				$tp->parse("letter_row");
			}
		}
		
		// parse block
		$tp->parse("letter_table");
	
	// setup asset
		// setup current letter
		if(isset($_GET['asset_letter'])) {
			$asset_letter = sanitize($_GET['asset_letter']);
		} else {
			$asset_letter = $alphabet[0]['asset_letter'];
		}
		
		// build query
		$query = "SELECT
				asset.asset_id AS asset_id,
				asset.asset_name AS asset_name,
				assetclass.assetclass_id AS assetclass_id,
				assetclass.assetclass_name AS assetclass_name
			FROM
				asset,
				assetclass
			WHERE
				SUBSTRING(asset.asset_name,1,1) = '" . $asset_letter . "'
				AND assetclass.assetclass_id=asset.assetclass_id
			ORDER BY
				asset.asset_name";
		
		// run query
		$assets = $db->db_select($query);
		
		// count results
		$asset_counter = count($assets);
		
		// counter to tpl
		$tp->set("asset_counter", $asset_counter);
	
		// any assets?
		if ($asset_counter>0) {
			// get objects
			foreach($assets AS $asset) {
				// send to tpl
				$tp->set("asset_id", $asset['asset_id']);
				$tp->set("asset_name", $asset['asset_name']);
				
				$tp->set("assetclass_id", $asset['assetclass_id']);
				$tp->set("assetclass_name", $asset['assetclass_name']);
				
				// parse row
				$tp->parse("asset_row");
			}
			
			// parse block
			$tp->parse("asset_table");
		} else {
			// hide block
			$tp->hide("asset_table");
		}
	
	// end page
		// output
		$tp->parse();
		$tp->spit();
		
		// end output
		include("footer.php");
?>