<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// start page
		// includes
		include("includes.php");
		
		// get id
		$assetclass_id = sanitize($_GET['assetclass_id']);
		
		// start output
		include("header.php");
		
		// set template
		$tp = new Template("tpl/assetclassview.tpl", $config_yapter_error);
		
		// set language variables
		$tp->setvars($lang);
	
	// setup assetclass
		// build query
		$query = "SELECT
				assetclass.assetclass_id AS assetclass_id,
				assetclass.assetclass_name AS assetclass_name,
				assetclassgroup.assetclassgroup_id AS assetclassgroup_id,
				assetclassgroup.assetclassgroup_name AS assetclassgroup_name
			FROM
				assetclass,
				assetclassgroup
			WHERE
				assetclass.assetclass_id=" . $assetclass_id . "
				AND assetclassgroup.assetclassgroup_id=assetclass.assetclassgroup_id";
		
		// run query
		$assetclass = $db->db_select($query);
		
		// send to tpl
		$tp->set("assetclass_id", $assetclass[0]['assetclass_id']);
		$tp->set("assetclass_name", $assetclass[0]['assetclass_name']);
		$tp->set("assetclass_selected", "");
		
		$tp->set("assetclassgroup_id", $assetclass[0]['assetclassgroup_id']);
		$tp->set("assetclassgroup_name", $assetclass[0]['assetclassgroup_name']);
	
	// setup asset
		// build query
		$query = "SELECT
				asset.asset_id AS asset_id,
				asset.asset_name AS asset_name
			FROM
				asset
			WHERE
				asset.assetclass_id='" . $assetclass_id . "'
			ORDER BY
				asset.asset_name";
		
		// run query
		$assets = $db->db_select($query);
		
		// count results
		$asset_counter = count($assets);
		
		// counter to tpl
		$tp->set("asset_counter", $asset_counter);
		
		// any assets?
		if ($asset_counter>0) {
			// sort using "natural order"
			// ksort($assets);
			
			// get objects
			foreach($assets AS $asset) {
				// send to tpl
				$tp->set("asset_id", $asset['asset_id']);
				$tp->set("asset_name", $asset['asset_name']);
				
				// parse row
				$tp->parse("asset_row");
			}
			
			// parse block
			$tp->parse("asset_table");
		} else {
			// hide block
			$tp->hide("asset_table");
		}
	
	// end page
		// output
		$tp->parse();
		$tp->spit();
	
		// footer
		include("footer.php");
?>