<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// start page
		// includes
		include("includes.php");
		
		// get id	
		$asset_id = sanitize($_GET['asset_id']);
		$node_ip = sanitize($_GET['node_ip']);
		$subnet_id = sanitize($_GET['subnet_id']);
		
		// start output
		include("header.php");
		
		// set template
		$tp = new Template("tpl/assignnodetoasset.tpl", $config_yapter_error);
		
		// set language variables
		$tp->setvars($lang);
	
	// to tpl
		$tp->set("node_ip", $node_ip);
	
	// setup asset
		// build query
		$query = "SELECT
				asset.asset_id AS asset_id,
				asset.asset_name AS asset_name
			FROM
				asset
			ORDER BY
				asset.asset_name";
		
		// run query
		$assets = $db->db_select($query);
		
		// count results
		$asset_counter = count($assets);
		
		// any assets?
		if ($asset_counter>0) {
			// get objects
			foreach($assets AS $asset) {
				// send to tpl
				$tp->set("asset_id", $asset['asset_id']);
				$tp->set("asset_name", $asset['asset_name']);
				
				if($asset['asset_id']==$asset_id) {
					$tp->set("asset_selected", "selected");
				} else {
					$tp->set("asset_selected", "");
				}
				
				// parse block
				$tp->parse("asset_row");
			}
			// parse block
			$tp->parse("asset_table");
		} else {
			// parse block
			$tp->hide("asset_table");
		}
	
	// setup subnet
		// build query
		$query = "SELECT
				subnet.subnet_id AS subnet_id,
				subnet.subnet_address AS subnet_address,
				subnet.subnet_mask AS subnet_mask
			FROM
				subnet
			ORDER BY
				INET_ATON(subnet.subnet_address)";
		
		// run query
		$subnets = $db->db_select($query);
		
		// count results
		$subnet_counter = count($subnets);
		
		// any subnets?
		if ($subnet_counter>0) {
			// get objects
			foreach($subnets AS $subnet) {
				// send to tpl
				$tp->set("subnet_id", $subnet['subnet_id']);
				$tp->set("subnet_address", $subnet['subnet_address']);
				$tp->set("subnet_mask", $subnet['subnet_mask']);
				
				if($subnet['subnet_id']==$subnet_id) {
					$tp->set("subnet_selected", "selected");
				} else {
					$tp->set("subnet_selected", "");
				}
				
				// parse block
				$tp->parse("subnet_row");
			}
			// parse block
			$tp->parse("subnet_table");
		} else {
			// parse block
			$tp->hide("subnet_table");
		}
	
	// end page
		// output
		$tp->parse();
		$tp->spit();
		
		// end output
		include("footer.php");
?>