<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// start page
		// includes
		include("includes.php");
		
		// get id	
		$location_parent = sanitize($_GET['location_parent']);
		
		// start output
		include("header.php");
		
		// set template
		$tp = new Template("tpl/locationadd.tpl", $config_yapter_error);
		
		// set language variables
		$tp->setvars($lang);
	
	// start parent
		// look for locations
			// build query
			$query = "SELECT
					location.location_id AS location_id,
					location.location_name AS location_name,
					location.location_parent AS location_parent
				FROM
					location
				ORDER BY
					location.location_name";
			
			// run query
			$locations = $db->db_select($query);
			
			// count results
			$location_counter = count($locations);
			
			// any loactions?
			if ($location_counter>0) {
				// get objects
				foreach($locations AS $location) {
					// create arrays
					$location_names[$location['location_id']] = $location['location_name'];
					$parents[$location['location_parent']][] = $location['location_id'];
				}
			}
		
		// look for parents
			// function to look for parents and create a new array for every child
			function location($parents, $parent = 0) {
				// loop array to check
				foreach($parents[$parent] as $child) {
					if(isset($parents[$child])) {
						// element has children
						$children[$child] = location($parents, $child);
					} else {
						// no children, set NULL
						$children[$child] = NULL;
					}
				}
				
				// and again...
				return $children;
			}
		
		// to tpl
			// recursive children check to template
			function checkchildren($locations, $level) {
				// include template class
				global $tp;
				
				// import location names
				global $location_names;
				
				// import location names
				global $location_parent;
				
				// action!
				foreach ($locations as $parent=>$child) {
					// send vars to template
					$tp->set("location_id", $parent);
		                	$tp->set("location_name", $location_names[$parent]);
		                	$tp->set("nbsp", str_repeat("-&nbsp;&nbsp;",$level));
		                	
		                	// set parent selected
		                	if($parent==$location_parent) {
						$tp->set("location_selected", "selected");
					} else {
						$tp->set("location_selected", "");
					}
		                	
		                	// parse block
		                	$tp->parse("location_row");
		                	
		                	// any children?
					if($child != "") {
						// yes, so do the loop again!
			                	checkchildren($child, $level+1);
					}
				}
				
				// parse and clear for the next round
				$tp->parse("location_table");
				$tp->clear("location_table");
			}
			
			// assemble the tree
			$tree = location($parents);
			
			// check for values and build template
			checkchildren($tree, 0);
	
	// end page
		// output
		$tp->parse();
		$tp->spit();
		
		// footer
		include("footer.php");
?>