<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// start page
		// includes
		include("includes.php");
		
		// start output
		include("header.php");
		
		// set template
		$tp = new Template("tpl/node.tpl", $config_yapter_error);
		
		// set language variables
		$tp->setvars($lang);
	
	// start node
		// setup view
			// subnet
			if(isset($_GET['subnet_id'])) {
				// get id
				$subnet_id = sanitize($_GET['subnet_id']);
				
				// build query part
				$subnet_view = "AND node.subnet_id=" . $subnet_id;
				
				// to tpl
				$tp->set("subnet_id", $subnet_id);
			} else {
				// to tpl
				$tp->set("subnet_id", "");
			}
		
		// build query
		$query = "SELECT
				asset.asset_id AS asset_id,
				asset.asset_name AS asset_name,
				node.node_id AS node_id,
				node.node_ip AS node_ip
			FROM
				asset,
				node
			WHERE
				asset.asset_id=node.asset_id
				" . $subnet_view . "
			GROUP BY
				node.node_id
			ORDER BY
				INET_ATON(node.node_ip)";
		
		// run query
		$nodes = $db->db_select($query);
		
		// count results
		$node_counter = count($nodes);
		
		// counter to tpl
		$tp->set("node_counter", $node_counter);
	
		// any nodes?
		if ($node_counter>0) {
			// get objects
			foreach($nodes AS $node) {
				// send to tpl
				$tp->set("asset_id", $node['asset_id']);
				$tp->set("asset_name", $node['asset_name']);
				
				$tp->set("node_id", $node['node_id']);
				$tp->set("node_ip", $node['node_ip']);
				
				// parse row
				$tp->parse("node_row");
			}
			
			// parse block
			$tp->parse("node_table");
		} else {
			// hide block
			$tp->hide("node_table");
		}
	
	// end page
		// output
		$tp->parse();
		$tp->spit();
		
		// end output
		include("footer.php");
?>