<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2007-2009 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// start page
		// includes
		include("includes.php");
		
		// start output
		include("header.php");
			
		// set template
		$tp = new Template("tpl/subnet.tpl", $config_yapter_error);
		
		// set language variables
		$tp->setvars($lang);
	
	// setup subnet
		// build query
		$query = "SELECT
				subnet.subnet_id AS subnet_id,
				subnet.subnet_address AS subnet_address,
				subnet.subnet_mask AS subnet_mask,
				COUNT(node.subnet_id) AS node_counter
			FROM
				subnet
			LEFT JOIN
				node
			ON
				node.subnet_id=subnet.subnet_id
			GROUP BY
				subnet.subnet_id
			ORDER BY
				INET_ATON(subnet.subnet_address)";
		
		// run query
		$subnets = $db->db_select($query);
		
		// count results
		$subnet_counter = count($subnets);
		
		// counter to tpl
		$tp->set("subnet_counter", $subnet_counter);
	
		// any subnets?
		if ($subnet_counter>0) {
			// get objects
			foreach($subnets AS $subnet) {
				// send to tpl
				$tp->set("subnet_id", $subnet['subnet_id']);
				$tp->set("subnet_address", $subnet['subnet_address']);
				$tp->set("subnet_mask", $subnet['subnet_mask']);
				$tp->set("node_counter", $subnet['node_counter']);
				
				// parse row
				$tp->parse("subnet_row");
			}
			
			// parse block
			$tp->parse("subnet_table");
		} else {
			// hide block
			$tp->hide("subnet_table");
		}
	
	// end page
		// output
		$tp->parse();
		$tp->spit();
		
		// end output
		include("footer.php");
?>